;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; separate wordlist for ";", to make helper definitions easier
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

0 quan zx-stx-last-colon-start ;; for stats

: (zx-;-common)  ( compile-;s? )
  system:?exec zx-?comp
  swap $c0de_0800 system:?pairs
  ?< forth-shadows:;s >?
  zx-smudge
  zx-exec!
  zx-compile-mode zxc-colon = not?error" ZX colon word was not started yet"
  zxc-none zx-compile-mode:!
  ;; statistics
  zx-here zx-stx-last-colon-start - zx-stat-tcode-bytes:+!
  << vsp-pop ?^|| else| >> pop-ctx ;

module SHADOW-SEMI
<disable-hash>

*: [
  system:?exec zx-?comp
  zx-compile-mode zxc-colon = not?error" invalid \'[\' usage in ZX mode"
  push-ctx
  \ -666 vsp-push
  \ voc-ctx: forth
  0 vsp-push
  vocid: forth vsp-push
  vocid: shadow-semi vsp-push
  vocid: zx-consts vsp-push
  voc-ctx: tcom
  zx-exec! ;

*: {#,}
  system:?exec zx-?comp
  zx-compile-mode zxc-colon = not?error" invalid \'{#,}\' usage in ZX mode"
  zx-#, ;

*: ]
  system:?exec zx-?exec
  zx-compile-mode zxc-colon = not?error" invalid \']\' usage in ZX mode"
  \ << vsp-pop -666 <> ?^|| else| >> pop-ctx
  << vsp-pop ?^|| else| >> pop-ctx
  zx-comp! ;

*: ;noexit  false (zx-;-common) ;
*: ;        true (zx-;-common) ;

end-module


end-module
