;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; and now for something completely different...
;; UrForth/Beast: Devastator -- Seductive and Deadly Forth System
;; Copyright (C) 2023-2024 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; very dumb and fragile local vars implementation
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(*
  {{ a0 a1 a2 | l0 l1 l2 }
    ...
  }
*)

extend-module system

0 variable loc-vocid
0 variable loc-count
0 variable loc-dp
0 variable loc-dp-saved
0 variable loc-hdr-dp-saved

: init-locdp
  here [ 32 1024 * ] {#,} + 3 + 3 ~and loc-dp ! hdr-here loc-hdr-dp-saved ! ;

: loc-restore
  loc-hdr-dp-saved @ dup not?error" wuta?!" (hdr-dp!) ;

: >loc-dict
  loc-dp @ not?error" wuta?!"
  here loc-dp @ u>= ?exit
  here loc-dp-saved ! loc-dp @ (dp!) ;

: >norm-dict
  here loc-dp @ u>= ?< here loc-dp !  loc-dp-saved @ (dp!) >? ;

: (loc-allot)  ( n )  loc-count +! ; latest-cfa (lstack-use):! -- for DO/FOR loops
: (loc-reset)  loc-dp !0 loc-hdr-dp-saved !0 loc-vocid !0 loc-count !0 ; (on-reset-system):!latest

: ensure-loc-vocid
  loc-vocid @ ?exit
  init-locdp >loc-dict  mk-wordlist-temp loc-vocid !  >norm-dict ;

: (local-does)  ( pfa )  ?comp @ #, \\ forth:(lbp+@) ;

: local-this@  ( local-pfa )  ['] (local-does) ?vocobject-this ;

module (locals-vocid)
*: !  system:?comp local-this@ @ #, \\ forth:(lbp+!) ;
end-module

: mk-local  ( addr count idx )
  ensure-loc-vocid
  >loc-dict push-cur loc-vocid @ current!
  nrot ['] (local-does) vocid: (locals-vocid) mk-vocid-vocobject immediate ( idx) ,
  >norm-dict pop-cur ;

: (LOC-ENTER)  lsp@ (lbp) @ >loc (lbp) ! ;
: (LOC-LEAVE)  loc> (lbp) ! ;

end-module


module locals-cwd
*: }
  system:?comp system:loc-vocid system:?pairs
  system:loc-count @ over - #, \\ forth:ldealloc
  dup system:loc-count !
  not?< \\ system:(loc-leave) system:loc-restore system:(loc-reset) pop-ctx pop-ctx >? ;

end-module (private)


*: {{
  system:?comp
  system:loc-count @ >r true >r 0 >r  ( | sv-count args? cc )
  << parse-name
     dup 1 = cand over c@ [char] } = ?v| 2drop |?
     dup 1 = cand over c@ [char] | = ?^| 2drop r1@ not?error" duplicate '|'" r> rdrop false >r >r |?
     system:loc-count dup 1+! @ system:mk-local
     r1@ ?< 1+r! >? ^|| >>
  r2@ not?< \\ system:(loc-enter) >?
  r@ #, \\ forth:(locmove)
  system:loc-count @ r> - rdrop r@ - dup ?< #, \\ forth:(lxalloc) || drop >?
  r@ system:loc-vocid ( oldloc ctlid )
  r> not?< push-ctx vocid: locals-cwd context!
           push-ctx system:loc-vocid @ context! >? ;
