;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; and now for something completely different...
;; UrForth/Beast: Devastator -- Seductive and Deadly Forth System
;; Copyright (C) 2023-2024 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; x86 32-bit prefix assembler: operand definitions
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


[HAS-WORD] UFO-NO-IP-REG [IFNOT]
true constant UFO-NO-IP-REG
[ENDIF]

UFO-NO-IP-REG [IFNOT]
  [HAS-WORD] UFO-IP-REG [IFNOT] (UFO-IP-REG) constant UFO-IP-REG [ENDIF]
[ENDIF]
[HAS-WORD] UFO-RP-REG [IFNOT] (UFO-RP-REG) constant UFO-RP-REG [ENDIF]
[HAS-WORD] UFO-SP-REG [IFNOT] (UFO-SP-REG) constant UFO-SP-REG [ENDIF]
[HAS-WORD] UFO-TOS-REG [IFNOT] (UFO-TOS-REG) constant UFO-TOS-REG [ENDIF]
[HAS-WORD] UFO-ADR-REG [IFNOT] (UFO-ADR-REG) constant UFO-ADR-REG [ENDIF]


[HAS-WORD] UFO-IP-REG [IF]
dd UFO-IP-REG reg32 mk-op-, UIP,
UFO-IP-REG rm32 mk-op-, [UIP],
UFO-IP-REG rm32+ mk-op-, [UIP+],
[ENDIF]
[HAS-WORD] UFO-RP-REG [IF]
dd UFO-RP-REG reg32 mk-op-, URP,
UFO-RP-REG rm32 mk-op-, [URP],
UFO-RP-REG rm32+ mk-op-, [URP+],
[ENDIF]
[HAS-WORD] UFO-SP-REG [IF]
dd UFO-SP-REG reg32 mk-op-, USP,
UFO-SP-REG rm32 mk-op-, [USP],
UFO-SP-REG rm32+ mk-op-, [USP+],
[ENDIF]
[HAS-WORD] UFO-TOS-REG [IF]
dd UFO-TOS-REG reg32 mk-op-, UTOS,
UFO-TOS-REG rm32 mk-op-, [UTOS],
UFO-TOS-REG rm32+ mk-op-, [UTOS+],
[ENDIF]
[HAS-WORD] UFO-ADR-REG [IF]
dd UFO-ADR-REG reg32 mk-op-, UADR,
UFO-ADR-REG rm32 mk-op-, [UADR],
UFO-ADR-REG rm32+ mk-op-, [UADR+],
[ENDIF]


[HAS-WORD] UFO-TOS-REG [IF]
UFO-TOS-REG 4 <> [IF]
UFO-TOS-REG 8 * 0o000 + si32 mk-op-, [UTOS*1],
UFO-TOS-REG 8 * 0o100 + si32 mk-op-, [UTOS*2],
UFO-TOS-REG 8 * 0o200 + si32 mk-op-, [UTOS*4],
UFO-TOS-REG 8 * 0o300 + si32 mk-op-, [UTOS*8],
UFO-TOS-REG 8 * 0o000 + si32+ mk-op-, [UTOS*1+],
UFO-TOS-REG 8 * 0o100 + si32+ mk-op-, [UTOS*2+],
UFO-TOS-REG 8 * 0o200 + si32+ mk-op-, [UTOS*4+],
UFO-TOS-REG 8 * 0o300 + si32+ mk-op-, [UTOS*8+],
[ENDIF] [ENDIF]

[HAS-WORD] UFO-ADR-REG [IF]
UFO-ADR-REG 4 <> [IF]
UFO-ADR-REG 8 * 0o000 + si32 mk-op-, [UADR*1],
UFO-ADR-REG 8 * 0o100 + si32 mk-op-, [UADR*2],
UFO-ADR-REG 8 * 0o200 + si32 mk-op-, [UADR*4],
UFO-ADR-REG 8 * 0o300 + si32 mk-op-, [UADR*8],
UFO-ADR-REG 8 * 0o000 + si32+ mk-op-, [UADR*1+],
UFO-ADR-REG 8 * 0o100 + si32+ mk-op-, [UADR*2+],
UFO-ADR-REG 8 * 0o200 + si32+ mk-op-, [UADR*4+],
UFO-ADR-REG 8 * 0o300 + si32+ mk-op-, [UADR*8+],
[ENDIF] [ENDIF]

[HAS-WORD] UFO-IP-REG [IF]
;; sib value; index-scale
UFO-IP-REG 4 <> [IF]
UFO-IP-REG 8 * 0o000 + si32 mk-op-, [UIP*1],
UFO-IP-REG 8 * 0o100 + si32 mk-op-, [UIP*2],
UFO-IP-REG 8 * 0o200 + si32 mk-op-, [UIP*4],
UFO-IP-REG 8 * 0o300 + si32 mk-op-, [UIP*8],
UFO-IP-REG 8 * 0o000 + si32+ mk-op-, [UIP*1+],
UFO-IP-REG 8 * 0o100 + si32+ mk-op-, [UIP*2+],
UFO-IP-REG 8 * 0o200 + si32+ mk-op-, [UIP*4+],
UFO-IP-REG 8 * 0o300 + si32+ mk-op-, [UIP*8+],
[ENDIF] [ENDIF]

[HAS-WORD] UFO-RP-REG [IF]
UFO-RP-REG 4 <> [IF]
UFO-RP-REG 8 * 0o000 + si32 mk-op-, [URP*1],
UFO-RP-REG 8 * 0o100 + si32 mk-op-, [URP*2],
UFO-RP-REG 8 * 0o200 + si32 mk-op-, [URP*4],
UFO-RP-REG 8 * 0o300 + si32 mk-op-, [URP*8],
UFO-RP-REG 8 * 0o000 + si32+ mk-op-, [URP*1+],
UFO-RP-REG 8 * 0o100 + si32+ mk-op-, [URP*2+],
UFO-RP-REG 8 * 0o200 + si32+ mk-op-, [URP*4+],
UFO-RP-REG 8 * 0o300 + si32+ mk-op-, [URP*8+],
[ENDIF] [ENDIF]

[HAS-WORD] UFO-SP-REG [IF]
UFO-SP-REG 4 <> [IF]
UFO-SP-REG 8 * 0o000 + si32 mk-op-, [USP*1],
UFO-SP-REG 8 * 0o100 + si32 mk-op-, [USP*2],
UFO-SP-REG 8 * 0o200 + si32 mk-op-, [USP*4],
UFO-SP-REG 8 * 0o300 + si32 mk-op-, [USP*8],
UFO-SP-REG 8 * 0o000 + si32+ mk-op-, [USP*1+],
UFO-SP-REG 8 * 0o100 + si32+ mk-op-, [USP*2+],
UFO-SP-REG 8 * 0o200 + si32+ mk-op-, [USP*4+],
UFO-SP-REG 8 * 0o300 + si32+ mk-op-, [USP*8+],
[ENDIF] [ENDIF]
