;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 16x16 XOR sprites, no runtime shifting
;; sprite data, directly included from "zx-80-libs-32-spr16-test.f"
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SPRITE-GFX RARROW-0
  ROW #..............#
  ROW .#..###........#
  ROW ....#.#.......#.
  ROW ....#.#.........
  ROW ....###.........
  ROW ..........#.....
  ROW .....###...#....
  ROW ....#########...
  ROW ....#########...
  ROW .....###...#....
  ROW ..........#.....
  ROW ................
  ROW ................
  ROW ..............#.
  ROW .#.............#
  ROW #..............#
END-SPRITE-GFX

SPRITE-GFX RARROW-1
  2 RSHIFT
  ROW #..............#
  ROW .#...#.........#
  ROW ....##........#.
  ROW .....#..........
  ROW ....###.........
  ROW ..........#.....
  ROW .....###...#....
  ROW ....#########...
  ROW ....#########...
  ROW .....###...#....
  ROW ..........#.....
  ROW ................
  ROW ................
  ROW ..............#.
  ROW .#.............#
  ROW #..............#
END-SPRITE-GFX

SPRITE-GFX RARROW-2
  4 RSHIFT
  ROW #..............#
  ROW .#..###........#
  ROW ......#.......#.
  ROW ....###.........
  ROW ....###.........
  ROW ..........#.....
  ROW .....###...#....
  ROW ....#########...
  ROW ....#########...
  ROW .....###...#....
  ROW ..........#.....
  ROW ................
  ROW ................
  ROW ..............#.
  ROW .#.............#
  ROW #..............#
END-SPRITE-GFX

SPRITE-GFX RARROW-3
  6 RSHIFT
  ROW #..............#
  ROW .#..###........#
  ROW ......#.......#.
  ROW ......#.........
  ROW ....###.........
  ROW ..........#.....
  ROW .....###...#....
  ROW ....#########...
  ROW ....#########...
  ROW .....###...#....
  ROW ..........#.....
  ROW ................
  ROW ................
  ROW ..............#.
  ROW .#.............#
  ROW #..............#
END-SPRITE-GFX

SPRITE-GFX LARROW-0
  H-MIRROR RARROW-0
END-SPRITE-GFX

SPRITE-GFX LARROW-1
  H-MIRROR RARROW-1
END-SPRITE-GFX

SPRITE-GFX LARROW-2
  H-MIRROR RARROW-2
END-SPRITE-GFX

SPRITE-GFX LARROW-3
  H-MIRROR RARROW-3
END-SPRITE-GFX

SPRITE-DEF SPR-FUN-ARROW
  ;; right
  @106 ATTR
  GFX: RARROW-0
  GFX: RARROW-1
  GFX: RARROW-2
  GFX: RARROW-3
  ;; left
  GFX: LARROW-0
  GFX: LARROW-1
  GFX: LARROW-2
  GFX: LARROW-3
END-SPRITE-DEF


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Rex walking

SPRITE-GFX RREX-0
  1 RSHIFT
  ROW ....#..#........
  ROW .....#.#........
  ROW ......#.##..#...
  ROW ..##.#.##..#....
  ROW .###..#.#####...
  ROW ###....###......
  ROW ##.#....#.###...
  ROW .##.#......#....
  ROW #..#.####.....#.
  ROW ##.##...##.#....
  ROW .....##..##..#..
  ROW ......##........
  ROW ...##.##........
  ROW ..##...##.#.....
  ROW ..##...###......
  ROW ...##...#.......
END-SPRITE-GFX

SPRITE-GFX RREX-1
  4 RSHIFT
  ROW ................
  ROW .....#..#.......
  ROW ......#.#.......
  ROW ...##..#.##..#..
  ROW ..###.#.##..#...
  ROW .###...#.#####..
  ROW .##.#...###.....
  ROW ..#..#...#.###..
  ROW .#.##.#.....#...
  ROW .##.#.####.....#
  ROW .....#...##.#...
  ROW ...#.###..##..#.
  ROW ...##..##.......
  ROW .###...##.......
  ROW ##....##........
  ROW ##....###.......
END-SPRITE-GFX

SPRITE-GFX RREX-2
  6 RSHIFT
  ROW ................
  ROW ....#..#........
  ROW .....#.#........
  ROW ..##..#.##..#...
  ROW .###.#.##..#....
  ROW ###...#.#####...
  ROW ##.#...###......
  ROW .#..#...#.###...
  ROW #.##.#.....#....
  ROW ##.#.####.....#.
  ROW ....#...##.#....
  ROW ....###..##..#..
  ROW ..##.##.........
  ROW .##..##.........
  ROW .##.##..........
  ROW ....###.........
END-SPRITE-GFX

SPRITE-GFX RREX-3
  7 RSHIFT
  ROW ....#..#........
  ROW .....#.#........
  ROW ..##..#.##..#...
  ROW .###.#.##..#....
  ROW ###...#.#####...
  ROW ##.#...###......
  ROW .#..#...#.###...
  ROW #.##.##....#....
  ROW ##.#...##.....#.
  ROW .....#..##.#....
  ROW .....###.##..#..
  ROW ......##.#......
  ROW ....###.#.......
  ROW ....##.#........
  ROW ...##.###.......
  ROW ...###..........
END-SPRITE-GFX

SPRITE-GFX LREX-0
  1 RSHIFT
  H-MIRROR RREX-3
END-SPRITE-GFX

SPRITE-GFX LREX-1
  2 RSHIFT
  H-MIRROR RREX-2
END-SPRITE-GFX

SPRITE-GFX LREX-2
  4 RSHIFT
  H-MIRROR RREX-1
END-SPRITE-GFX

SPRITE-GFX LREX-3
  7 RSHIFT
  H-MIRROR RREX-0
END-SPRITE-GFX


SPRITE-DEF SPR-REX-WALK
  ;; right
  @004 ATTR
  GFX: RREX-0
  GFX: RREX-1
  GFX: RREX-2
  GFX: RREX-3
  ;; left
  GFX: LREX-0
  GFX: LREX-1
  GFX: LREX-2
  GFX: LREX-3
END-SPRITE-DEF


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Rex falling

SPRITE-GFX RREX-FALL-0
  ROW .....#..#.......
  ROW ......#.#.......
  ROW ...##..#.##..#..
  ROW ..###.#.##..#...
  ROW .###...#.#####..
  ROW .##.#...###.....
  ROW ..#..#...#.###..
  ROW .#.##.#.....#...
  ROW .##.#..###.....#
  ROW .........##.#...
  ROW ......###.##..#.
  ROW .......##.#.....
  ROW .....###.#......
  ROW .....##.#.......
  ROW ....##.###......
  ROW ....###.........
END-SPRITE-GFX

SPRITE-GFX RREX-FALL-1
  2 RSHIFT
  COPY RREX-FALL-0
END-SPRITE-GFX

SPRITE-GFX RREX-FALL-2
  4 RSHIFT
  COPY RREX-FALL-0
END-SPRITE-GFX

SPRITE-GFX RREX-FALL-3
  6 RSHIFT
  COPY RREX-FALL-0
END-SPRITE-GFX

SPRITE-GFX LREX-FALL-0
  H-MIRROR RREX-FALL-3
END-SPRITE-GFX

SPRITE-GFX LREX-FALL-1
  H-MIRROR RREX-FALL-2
END-SPRITE-GFX

SPRITE-GFX LREX-FALL-2
  H-MIRROR RREX-FALL-1
END-SPRITE-GFX

SPRITE-GFX LREX-FALL-3
  H-MIRROR RREX-FALL-0
END-SPRITE-GFX


SPRITE-DEF SPR-REX-FALL
  ;; right
  @004 ATTR
  GFX: RREX-FALL-0
  GFX: RREX-FALL-1
  GFX: RREX-FALL-2
  GFX: RREX-FALL-3
  ;; left
  GFX: LREX-FALL-0
  GFX: LREX-FALL-1
  GFX: LREX-FALL-2
  GFX: LREX-FALL-3
END-SPRITE-DEF



;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soldier walking

SPRITE-GFX RSOLDIER-0
  ROW ................
  ROW ..#...##........
  ROW .....#..........
  ROW ..#..#..........
  ROW ...#..###.......
  ROW ..#.............
  ROW ....#.#.#.......
  ROW ...#....#.##.#..
  ROW ....##...#......
  ROW ..#......#......
  ROW ......#.........
  ROW ...#..##........
  ROW .......#........
  ROW ..#.............
  ROW .#......#.#.....
  ROW ..#......#......
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-1
  2 RSHIFT
  ROW ................
  ROW ..#...##........
  ROW .....#..........
  ROW ..#..#..........
  ROW ...#..###.......
  ROW ..#.............
  ROW ....#.#.#.......
  ROW ...#....#.##.#..
  ROW ....##...#......
  ROW ..#......#......
  ROW ......##........
  ROW ....#..##.......
  ROW ........#.......
  ROW ..#.............
  ROW .#.....#........
  ROW .#.....##.......
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-2
  4 RSHIFT
  ROW ................
  ROW ....#...##......
  ROW .......#........
  ROW ....#..#........
  ROW .....#..###.....
  ROW ....#...........
  ROW ......#.#.#.....
  ROW .....#....#.##.#
  ROW ......##...#....
  ROW ....#....#.#....
  ROW ......##........
  ROW .......#........
  ROW ...#..#.........
  ROW ..#.............
  ROW ..#..#..........
  ROW .....##.........
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-3
  6 RSHIFT
  ROW ...#...##.......
  ROW ......#.........
  ROW ...#..#.........
  ROW ....#..###......
  ROW ...#............
  ROW .....#.#.#......
  ROW ....#....#.##.#.
  ROW .....##...#.....
  ROW ..........#.....
  ROW ...#..##........
  ROW ......#.........
  ROW .....##..#......
  ROW ................
  ROW ....#...#.......
  ROW ...#...#........
  ROW ...##...#.......
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-0
  H-MIRROR RSOLDIER-0
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-1
  H-MIRROR RSOLDIER-1
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-2
  H-MIRROR RSOLDIER-2
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-3
  H-MIRROR RSOLDIER-3
END-SPRITE-GFX


SPRITE-DEF SPR-SOLDIER-WALK
  ;; right
  @001 ATTR
  GFX: RSOLDIER-0
  GFX: RSOLDIER-1
  GFX: RSOLDIER-2
  GFX: RSOLDIER-3
  ;; left
  GFX: LSOLDIER-0
  GFX: LSOLDIER-1
  GFX: LSOLDIER-2
  GFX: LSOLDIER-3
END-SPRITE-DEF


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soldier shooting

SPRITE-GFX RSOLDIER-SHOOT-0
  ROW ...#...##.......
  ROW ......#.........
  ROW ...#..#.........
  ROW ....#..###......
  ROW ...#............
  ROW .....#.#.#......
  ROW ....#....#.##.#.
  ROW .....##...#.....
  ROW ..........#.....
  ROW ...#..##........
  ROW ......#.........
  ROW .....##..#......
  ROW ................
  ROW ....#...#.......
  ROW ...#...#........
  ROW ...##...#.......
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-SHOOT-1
  2 RSHIFT
  COPY RSOLDIER-SHOOT-0
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-SHOOT-2
  4 RSHIFT
  COPY RSOLDIER-SHOOT-0
END-SPRITE-GFX

SPRITE-GFX RSOLDIER-SHOOT-3
  6 RSHIFT
  COPY RSOLDIER-SHOOT-0
END-SPRITE-GFX


SPRITE-GFX LSOLDIER-SHOOT-0
  H-MIRROR RSOLDIER-SHOOT-0
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-SHOOT-1
  H-MIRROR RSOLDIER-SHOOT-1
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-SHOOT-2
  H-MIRROR RSOLDIER-SHOOT-2
END-SPRITE-GFX

SPRITE-GFX LSOLDIER-SHOOT-3
  H-MIRROR RSOLDIER-SHOOT-3
END-SPRITE-GFX


SPRITE-DEF SPR-SOLDIER-SHOOT
  ;; right
  @001 ATTR
  GFX: RSOLDIER-SHOOT-0
  GFX: RSOLDIER-SHOOT-1
  GFX: RSOLDIER-SHOOT-2
  GFX: RSOLDIER-SHOOT-3
  ;; left
  GFX: LSOLDIER-SHOOT-0
  GFX: LSOLDIER-SHOOT-1
  GFX: LSOLDIER-SHOOT-2
  GFX: LSOLDIER-SHOOT-3
END-SPRITE-DEF


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Soldier dying

SPRITE-GFX LDYING-0
  ROW ......#.........
  ROW ................
  ROW ....#...#.......
  ROW ...###..##......
  ROW .....##.........
  ROW .....#..##......
  ROW ....#.....##....
  ROW .......#....#...
  ROW ........#.......
  ROW ..........#.....
  ROW .....#..##......
  ROW ....##.##.......
  ROW ......##........
  ROW ..#.....#.......
  ROW .........#......
  ROW ........#.......
END-SPRITE-GFX

SPRITE-GFX LDYING-1
  ROW ................
  ROW .........##..#..
  ROW ..........##....
  ROW ..........##.#..
  ROW ........###.##..
  ROW .....#.......#..
  ROW .......##..#....
  ROW .........#..#...
  ROW ........#..#.#..
  ROW ..............#.
  ROW .........##...#.
  ROW ........#.......
  ROW .......#........
  ROW ........#.......
  ROW ........#.......
  ROW .......#........
END-SPRITE-GFX

SPRITE-GFX LDYING-2
  2 RSHIFT
  ROW .....#..........
  ROW ................
  ROW .......#........
  ROW .......##....#..
  ROW ......#...#..##.
  ROW ...........###.#
  ROW ...##..#.#..#...
  ROW #.#..#.#......##
  ROW .#...##.##.#.##.
  ROW ....##.....#....
  ROW ....#....#..#...
  ROW ...#........#...
  ROW ...#............
  ROW .##.............
  ROW ................
  ROW ................
END-SPRITE-GFX

SPRITE-GFX LDYING-3
  6 RSHIFT
  ROW .....#..........
  ROW ................
  ROW .......#........
  ROW .......##....#..
  ROW ......#...#..##.
  ROW ...........###.#
  ROW ...##..#.#..#...
  ROW #.#..#.#......##
  ROW .#...##.##.#.##.
  ROW ....##.....#....
  ROW ....#....#..#...
  ROW ...#........#...
  ROW ...#............
  ROW .##.............
  ROW ................
  ROW ................
END-SPRITE-GFX

SPRITE-GFX RDYING-0
  H-MIRROR LDYING-0
END-SPRITE-GFX

SPRITE-GFX RDYING-1
  H-MIRROR LDYING-1
END-SPRITE-GFX

SPRITE-GFX RDYING-2
  H-MIRROR LDYING-2
END-SPRITE-GFX

SPRITE-GFX RDYING-3
  H-MIRROR LDYING-3
END-SPRITE-GFX


SPRITE-DEF SPR-SOLDIER-DYING
  ;; right
  @001 ATTR
  GFX: RDYING-0
  GFX: RDYING-1
  GFX: RDYING-2
  GFX: RDYING-3
  ;; left
  GFX: LDYING-0
  GFX: LDYING-1
  GFX: LDYING-2
  GFX: LDYING-3
END-SPRITE-DEF


;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Skull

;; the following sprites were taken from:
;; https://spectrumcomputing.co.uk/entry/34417/ZX-Spectrum/All_Hallows
;; i will remove them later, but for now i want something... sinister for tests. ;-)
;; please, don't use those sprites in your software!

SPRITE-GFX SKULL-0
  ROW ###.########.###
  ROW .##############.
  ROW ..####.##.####..
  ROW .###..#..#..###.
  ROW .##....##....##.
  ROW .##.##.##.##.##.
  ROW ..#.##.##.##.#..
  ROW .##...####...##.
  ROW ..##.##..##.##..
  ROW ....##....##....
  ROW ....########....
  ROW ......#..#......
  ROW ....##.##.##....
  ROW ....##.##.##....
  ROW ....##.##.##....
  ROW .....######.....
END-SPRITE-GFX

SPRITE-GFX SKULL-1
  2 RSHIFT
  ROW ###.########.###
  ROW .##############.
  ROW ..####.##.####..
  ROW .###..#..#..###.
  ROW .##....##....##.
  ROW .##.##.##.##.##.
  ROW ..##...##...##..
  ROW .##.###..###.##.
  ROW ..##.#....#.##..
  ROW ....########....
  ROW ......#..#......
  ROW ....##.##.##....
  ROW ....##.##.##....
  ROW ................
  ROW ....##.##.##....
  ROW .....######.....
END-SPRITE-GFX

SPRITE-GFX SKULL-2
  4 RSHIFT
  ROW ###.########.###
  ROW .#####.##.#####.
  ROW ..##.##..##.##..
  ROW .##...####...##.
  ROW .##.##.##.##.##.
  ROW ..##...##...##..
  ROW .##.###..###.##.
  ROW ..##.#....#.##..
  ROW ...##########...
  ROW ......#..#......
  ROW ....##.##.##....
  ROW ....##.##.##....
  ROW ................
  ROW ................
  ROW ....##.##.##....
  ROW .....######.....
END-SPRITE-GFX

SPRITE-GFX SKULL-3
  6 RSHIFT
  ROW ###.########.###
  ROW .##############.
  ROW ..####.##.####..
  ROW .###.##..##.###.
  ROW .##...####...##.
  ROW .##.##.##.##.##.
  ROW ..##...##...##..
  ROW .##.###..###.##.
  ROW ..##.#....#.##..
  ROW ....########....
  ROW ......#..#......
  ROW ....##.##.##....
  ROW ....##.##.##....
  ROW ................
  ROW ....##.##.##....
  ROW .....######.....
END-SPRITE-GFX

SPRITE-DEF SPR-SKULL
  @002 ATTR
  GFX: SKULL-0
  GFX: SKULL-1
  GFX: SKULL-2
  GFX: SKULL-3
END-SPRITE-DEF
