;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Z80 Abersoft fig-FORTH recompiled
;; Copyright (C) 2024 Ketmar Dark // Invisible Vector
;; Understanding is not required. Only obedience.
;; GPLv3 ONLY
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; helpers for code words
;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


extend-module TCOM

0 quan zx-stx-last-code-start ;; for stats

module ZXF-CODE
<disable-hash>

extend-module z80asm:instr
;; macro
: next
  z80asm:flush
  z80asm:postfix? >r
  true z80asm:postfix!
  \ " i-next" z80-labman:use-label # jp
  (ix) jp
  r> z80asm:postfix! ;
: next-push-hl
  z80asm:flush
  z80asm:postfix? >r
  true z80asm:postfix!
  " i-next-push-hl" z80-labman:use-label # jp
  r> z80asm:postfix! ;
: next-push-de-hl
  z80asm:flush
  z80asm:postfix? >r
  true z80asm:postfix!
  " i-next-push-de-hl" z80-labman:use-label # jp
  r> z80asm:postfix! ;
end-module

: ;code-no-next
  zx-compile-mode zxc-code = not?error" ZX code word was not started yet"
  z80asm:flush
  zx-fix-dp
  pop-ctx [\\] zxa:zx-code-def:<end-asm>
  zxc-none zx-compile-mode:!
  ;; statistics
  zx-here zx-stx-last-code-start - zx-stat-mcode-bytes:+! ;

: ;code
  z80asm:instr:next
  ;code-no-next ;

: ;code-push-hl
  z80asm:instr:next-push-hl
  ;code-no-next ;

: ;code-push-de-hl
  z80asm:instr:next-push-de-hl
  ;code-no-next ;

end-module


end-module
